dnl $Id: config.m4,v 1.2 2004/04/27 19:36:38 johannes Exp $
dnl config.m4 for extension idn

PHP_ARG_WITH(idn, for GNU Libidn support,
[  --with-idn[=DIR]        Include GNU Libidn support])

if test "$PHP_IDN" != "no"; then
  SEARCH_PATH="/usr/local /usr"
  SEARCH_FOR="/include/idna.h"

  if test -r $PHP_IDN/$SEARCH_FOR; then # path given as parameter
    IDN_DIR=$PHP_IDN
  else
    AC_MSG_CHECKING([for idn files in default path])
    for i in $SEARCH_PATH ; do
      if test -r $i/$SEARCH_FOR; then
        IDN_DIR=$i
        AC_MSG_RESULT(found in $i)
      fi
    done
  fi

  if test -z "$IDN_DIR"; then
    AC_MSG_RESULT([not found])
    AC_MSG_ERROR([Please reinstall the GNU Libidn distribution])
  fi

  AC_MSG_CHECKING([for optional tld files])
  if test -r "$IDN_DIR/include/tld.h"; then
    AC_MSG_RESULT(yes)
    AC_DEFINE(HAVE_TLD,1,[ ])
  else
    AC_MSG_RESULT([no])
  fi

  PHP_ADD_INCLUDE($IDN_DIR/include)

  dnl # --with-idn -> check for lib and symbol presence
  LIBNAME=idn
  LIBSYMBOL=stringprep_check_version

  PHP_CHECK_LIBRARY($LIBNAME,$LIBSYMBOL,
  [
    PHP_ADD_LIBRARY_WITH_PATH($LIBNAME, $IDN_DIR/lib, IDN_SHARED_LIBADD)
    AC_DEFINE(HAVE_IDNLIB,1,[ ])
  ],[
    AC_MSG_ERROR([wrong idn lib version or lib not found])
  ],[
    -L$IDN_DIR/lib -lm -ldl
  ])
  PHP_SUBST(IDN_SHARED_LIBADD)

  PHP_NEW_EXTENSION(idn, idn.c, $ext_shared)
fi
