--TEST--
idn: Check GNU libidn idn_to_ascii function
--SKIPIF--
<?php @dl('idn.so'); if (!extension_loaded("idn")) print "skip"; ?>
--POST--
--GET--
--FILE--
<?php 
//
// This file contains ISO-8859-1 and UTF-8 mixed!
//

// A failing function returns FALSE and raises a warning.
function myErrorHandler($errno, $errstr, $errfile, $errline) {
    if (error_reporting() == 0) return;
    printf("ERROR: %s", $errstr);
}
set_error_handler("myErrorHandler");

// Convert from native to encoded format
printf("%s (%d)\n", idn_to_ascii(utf8_encode('tst.de'), $errorcode), $errorcode); // ISO-8859-1
printf("%s (%d)\n", idn_to_ascii('t'.chr(0xC3).chr(0xA4).'st.de', $errorcode), $errorcode); // UTF-8
printf("%s\n", idn_to_ascii('test.de')); // ASCII

// Cannot convert a domain name to ASCII that contains non-ASCII chars but already starts with "xn--"
printf("%s\n", idn_to_ascii('xn--'.chr(0xC3).chr(0xA4)));

// Cannot use ISO-8859-1 as input.
$ascii = @idn_to_ascii("", $errorcode);
if ($ascii === false) {
    if ($errorcode == IDNA_STRINGPREP_ERROR) {
        printf("Detected IDNA Stringprep error: %s\n", idn_strerror($errorcode));
    } else {
        printf("Detected different IDNA error %d: %s\n", $errorcode, idn_strerror($errorcode));
    }
}

?>

--EXPECT--
xn--tst-qla.de (0)
xn--tst-qla.de (0)
test.de
ERROR: idn_to_ascii(): Could not convert xn--ä to ASCII: Input already contain ACE prefix (`xn--')
Detected IDNA Stringprep error: String preparation failed
