--TEST--
idn: Check GNU libidn idn_to_utf8 function
--SKIPIF--
<?php @dl('idn.so'); if (!extension_loaded("idn")) print "skip"; ?>
--POST--
--GET--
--FILE--
<?php 
//
// This file contains ISO-8859-1 and UTF-8 mixed!
//

// A failing function returns FALSE and raises a warning.
function myErrorHandler($errno, $errstr, $errfile, $errline) {
    if (error_reporting() == 0) return;
    printf("ERROR: %s", $errstr);
}
set_error_handler("myErrorHandler");

printf("%s (%d)\n", idn_to_utf8("xn--tst-qla.de", $errorcode), $errorcode); // ASCII to UTF-8
printf("%s (%d)\n", utf8_decode(idn_to_utf8("xn--tst-qla.de", $errorcode)), $errorcode); // ASCII to ISO-8859-1
printf("%s (%d)\n", idn_to_utf8("test.de", $errorcode), $errorcode); // ASCII to ASCII

// rfc3490 4.2: "ToUnicode never fails. If any step fails, then the original input
// sequence is returned immediately in that step."
printf("%s (%d)\n", idn_to_utf8("xn--xn--xn--", $errorcode), $errorcode);

// Impossible for libidn to catch the wrong charset. The user expected xn--tst-qla.de
printf("%s (%d)\n", idn_to_ascii("tst.de", $errorcode), $errorcode);
?>

--EXPECT--
täst.de (0)
tst.de (0)
test.de (0)
xn--xn--xn-- (0)
xn--t-p75a.de (0)
